diff -urpN ksmbd-tools-3.1.0/configure.ac ksmbd-tools-3.1.0.new/configure.ac
--- ksmbd-tools-3.1.0/configure.ac	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/configure.ac	2020-01-25 02:01:29.299043469 +0400
@@ -48,11 +48,6 @@ AC_CHECK_FUNCS_ONCE([
 	recvmsg
 ])
 
-PKG_CHECK_MODULES([GLIB], [glib-2.0 >= 2.40], [has_glib2=1], [has_glib2=0])
-AS_IF([test "$has_glib2" -eq 0],
-      AC_MSG_ERROR([No glib2 (libglib2.0-dev or glib2-devel) was found])
-])
-
 has_libnl_ver=0
 dnl libnl-genl-3.0.pc pkg-config file just for libnl-3.0 case.
 PKG_CHECK_MODULES([LIBNL], [libnl-3.0 >= 3.0 libnl-genl-3.0 >= 3.0], [has_libnl_ver=3], [has_libnl_ver=0])
diff -urpN ksmbd-tools-3.1.0/include/config_parser.h ksmbd-tools-3.1.0.new/include/config_parser.h
--- ksmbd-tools-3.1.0/include/config_parser.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/config_parser.h	2020-01-25 02:01:29.299043469 +0400
@@ -8,15 +8,15 @@
 #ifndef __USMBD_CONFIG_H__
 #define __USMBD_CONFIG_H__
 
-#include <glib.h>
+#include <usmbdtools.h>
 
 struct smbconf_group {
 	char			*name;
-	GHashTable		*kv;
+	struct LIST		*kv;
 };
 
 struct smbconf_parser {
-	GHashTable		*groups;
+	struct LIST		*groups;
 	struct smbconf_group	*current;
 };
 
diff -urpN ksmbd-tools-3.1.0/include/management/session.h ksmbd-tools-3.1.0.new/include/management/session.h
--- ksmbd-tools-3.1.0/include/management/session.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/management/session.h	2020-01-25 02:01:29.299043469 +0400
@@ -8,7 +8,7 @@
 #ifndef __MANAGEMENT_TCONNECTION_H__
 #define __MANAGEMENT_TCONNECTION_H__
 
-#include <glib.h>
+#include <usmbdtools.h>
 
 struct usmbd_user;
 
@@ -17,8 +17,8 @@ struct usmbd_session {
 
 	struct usmbd_user	*user;
 
-	GRWLock			update_lock;
-	GList			*tree_conns;
+	pthread_rwlock_t	update_lock;
+	struct LIST		*tree_conns;
 	int			ref_counter;
 };
 
diff -urpN ksmbd-tools-3.1.0/include/management/share.h ksmbd-tools-3.1.0.new/include/management/share.h
--- ksmbd-tools-3.1.0/include/management/share.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/management/share.h	2020-01-26 13:58:13.864726159 +0400
@@ -8,7 +8,7 @@
 #ifndef __MANAGEMENT_SHARE_H__
 #define __MANAGEMENT_SHARE_H__
 
-#include <glib.h>
+#include <usmbdtools.h>
 
 
 enum share_users {
@@ -44,7 +44,7 @@ struct usmbd_share {
 	int		max_connections;
 	int		num_connections;
 
-	GRWLock		update_lock;
+	pthread_rwlock_t	update_lock;
 	int		ref_count;
 
 	unsigned short	create_mask;
@@ -61,19 +61,19 @@ struct usmbd_share {
 
 	char		*guest_account;
 
-	GHashTable	*maps[USMBD_SHARE_USERS_MAX];
+	struct LIST	*maps[USMBD_SHARE_USERS_MAX];
 	/*
 	 * FIXME
 	 * We need to support IP ranges, netmasks, etc.
 	 * This is just a silly hostname matching, hence
 	 * these two are not in ->maps[].
 	 */
-	GHashTable	*hosts_allow_map;
+	struct LIST	*hosts_allow_map;
 	/* Deny access */
-	GHashTable	*hosts_deny_map;
+	struct LIST	*hosts_deny_map;
 
 	/* One lock to rule them all [as of now] */
-	GRWLock		maps_lock;
+	pthread_rwlock_t maps_lock;
 
 	char		*comment;
 };
@@ -158,10 +158,8 @@ int shm_lookup_hosts_map(struct usmbd_sh
 int shm_open_connection(struct usmbd_share *share);
 int shm_close_connection(struct usmbd_share *share);
 
-typedef void (*walk_shares)(gpointer key,
-			    gpointer value,
-			    gpointer user_data);
-void for_each_usmbd_share(walk_shares cb, gpointer user_data);
+typedef void (*walk_shares)(void *item, unsigned long long id, void *user_data);
+void foreach_usmbd_share(walk_shares cb, void *user_data);
 
 struct usmbd_share_config_response;
 
diff -urpN ksmbd-tools-3.1.0/include/management/tree_conn.h ksmbd-tools-3.1.0.new/include/management/tree_conn.h
--- ksmbd-tools-3.1.0/include/management/tree_conn.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/management/tree_conn.h	2020-01-25 02:01:29.299043469 +0400
@@ -8,8 +8,6 @@
 #ifndef __MANAGEMENT_TREE_CONN_H__
 #define __MANAGEMENT_TREE_CONN_H__
 
-#include <glib.h>
-
 struct usmbd_share;
 
 struct usmbd_tree_conn {
diff -urpN ksmbd-tools-3.1.0/include/management/user.h ksmbd-tools-3.1.0.new/include/management/user.h
--- ksmbd-tools-3.1.0/include/management/user.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/management/user.h	2020-01-26 13:58:13.864726159 +0400
@@ -10,7 +10,6 @@
 
 #include <sys/types.h>
 #include <pwd.h>
-#include <glib.h>
 
 struct usmbd_user {
 	char		*name;
@@ -24,7 +23,7 @@ struct usmbd_user {
 
 	int		ref_count;
 	int		flags;
-	GRWLock		update_lock;
+	pthread_rwlock_t	update_lock;
 };
 
 static inline void set_user_flag(struct usmbd_user *user, int bit)
@@ -50,10 +49,10 @@ int usm_add_update_user_from_pwdentry(ch
 void usm_destroy(void);
 int usm_init(void);
 
-typedef void (*walk_users)(gpointer key,
-			   gpointer value,
-			   gpointer user_data);
-void for_each_usmbd_user(walk_users cb, gpointer user_data);
+typedef void (*walk_users)(void *value,
+			   unsigned long long key,
+			   void *user_data);
+void foreach_usmbd_user(walk_users cb, void *user_data);
 
 struct usmbd_login_request;
 struct usmbd_login_response;
diff -urpN ksmbd-tools-3.1.0/include/rpc.h ksmbd-tools-3.1.0.new/include/rpc.h
--- ksmbd-tools-3.1.0/include/rpc.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/rpc.h	2020-01-25 02:01:29.299043469 +0400
@@ -9,7 +9,6 @@
 #define __USMBD_RPC_H__
 
 #include <linux/types.h>
-#include <glib.h>
 
 #define USMBD_DCERPC_LITTLE_ENDIAN	(1 << 0)
 #define USMBD_DCERPC_ALIGN2		(1 << 1)
@@ -251,27 +250,27 @@ struct usmbd_dcerpc {
 	 * restriction
 	 */
 	int			(*entry_size)(struct usmbd_dcerpc *dce,
-					      gpointer entry);
+					      void *entry);
 	/*
 	 * Entry representation under the given container level
 	 * restriction for array representation
 	 */
 	int			(*entry_rep)(struct usmbd_dcerpc *dce,
-					      gpointer entry);
+					      void *entry);
 	/*
 	 * Entry data under the given container level restriction
 	 * for array representation
 	 */
 	int			(*entry_data)(struct usmbd_dcerpc *dce,
-					      gpointer entry);
+					      void *entry);
 };
 
 struct usmbd_rpc_pipe {
-	unsigned int		id;
+	unsigned int	id;
 
 	int			num_entries;
 	int			num_processed;
-	GArray			*entries;
+	struct LIST		*entries;
 
 	struct usmbd_dcerpc	*dce;
 
diff -urpN ksmbd-tools-3.1.0/include/usmbdtools.h ksmbd-tools-3.1.0.new/include/usmbdtools.h
--- ksmbd-tools-3.1.0/include/usmbdtools.h	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/include/usmbdtools.h	2020-01-26 14:06:09.634412732 +0400
@@ -23,35 +23,99 @@
 #include <time.h>
 #include <poll.h>
 #include <getopt.h>
-#include <glib.h>
+#include <pthread.h>
 
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
 
+char *ascii_strdown(char *str, size_t len);
+
+int atomic_int_add(volatile int *atomic, int val);
+void atomic_int_inc(volatile int *atomic);
+
+int atomic_int_compare_and_exchange(volatile int *atomic,
+				    int oldval, int newval);
+
+#define KEY_ID 0x0
+#define KEY_STRING 0x1
+struct LIST {
+	struct LIST *prev;
+	struct LIST *next;
+	int type;
+	unsigned long long id;
+	char *keystr;
+	void *item;
+};
+
+struct LIST *list_init(struct LIST **list);
+long long list_maxid(struct LIST **list);
+int list_add_str(struct LIST **list, void *item, char *str);
+int list_add(struct LIST **list, void *item, unsigned long long id);
+void list_append(struct LIST **list, void *item);
+int list_remove(struct LIST **list, unsigned long long id);
+int list_remove_dec(struct LIST **list, unsigned long long id);
+void *list_get(struct LIST **list, unsigned long long id);
+void list_clear(struct LIST **list);
+int list_foreach(struct LIST **list,
+		 void (*func)(void *item, unsigned long long id,
+			      void *user_data), void *user_data);
+
+static unsigned long long list_tokey(void *ptr)
+{
+	size_t p = (size_t)ptr;
+	return p;
+}
+
+static void *list_fromkey(unsigned long long key)
+{
+	size_t p = key;
+
+	return (void *)p;
+}
+
+typedef enum {
+	step_A, step_B, step_C
+} base64_encodestep;
+
+typedef struct {
+	base64_encodestep step;
+	char result;
+	int stepcount;
+} base64_encodestate;
+
+typedef enum {
+	step_a, step_b, step_c, step_d
+} base64_decodestep;
+
+typedef struct {
+	base64_decodestep step;
+	char plainchar;
+} base64_decodestate;
+
 struct smbconf_global {
-	int			flags;
-	int			map_to_guest;
-	char			*guest_account;
-
-	char			*server_string;
-	char			*work_group;
-	char			*netbios_name;
-	char			*server_min_protocol;
-	char			*server_max_protocol;
-	char			*root_dir;
-	int			server_signing;
-	int			sessions_cap;
-	int			restrict_anon;
-	unsigned short		tcp_port;
-	unsigned short		ipc_timeout;
-	unsigned int		deadtime;
-	int			bind_interfaces_only;
-	char			**interfaces;
-	unsigned long		file_max;
-	unsigned int		smb2_max_read;
-	unsigned int		smb2_max_write;
-	unsigned int		smb2_max_trans;
+	int flags;
+	int map_to_guest;
+	char *guest_account;
+
+	char *server_string;
+	char *work_group;
+	char *netbios_name;
+	char *server_min_protocol;
+	char *server_max_protocol;
+	char *root_dir;
+	int server_signing;
+	int sessions_cap;
+	int restrict_anon;
+	unsigned short tcp_port;
+	unsigned short ipc_timeout;
+	unsigned int deadtime;
+	int bind_interfaces_only;
+	char **interfaces;
+	unsigned long file_max;
+	unsigned int smb2_max_read;
+	unsigned int smb2_max_write;
+	unsigned int smb2_max_trans;
 };
 
 #define USMBD_LOCK_FILE		"/tmp/usmbd.lock"
@@ -113,7 +177,7 @@ static int log_level = PR_INFO;
  */
 char *strerr(int err);
 
-__attribute__ ((format (printf, 2, 3)))
+__attribute__((format(printf, 2, 3)))
 extern void __pr_log(int level, const char *fmt, ...);
 extern void set_logger_app_name(const char *an);
 extern const char *get_logger_app_name(void);
@@ -141,20 +205,19 @@ void pr_hex_dump(const void *mem, size_t
 char *base64_encode(unsigned char *src, size_t srclen);
 unsigned char *base64_decode(char const *src, size_t *dstlen);
 
-gchar *usmbd_gconvert(const gchar *str,
-		      gssize       str_len,
-		      int          to_codeset,
-		      int          from_codeset,
-		      gsize       *bytes_read,
-		      gsize       *bytes_written);
+char *usmbd_gconvert(const char *str,
+		     size_t str_len,
+		     int to_codeset,
+		     int from_codeset,
+		     size_t *bytes_read, size_t *bytes_written);
 
 enum charset_idx {
-	USMBD_CHARSET_UTF8		= 0,
+	USMBD_CHARSET_UTF8 = 0,
 	USMBD_CHARSET_UTF16LE,
 	USMBD_CHARSET_UCS2LE,
 	USMBD_CHARSET_UTF16BE,
 	USMBD_CHARSET_UCS2BE,
-	USMBD_CHARSET_MAX		= 5,
+	USMBD_CHARSET_MAX = 5,
 };
 
 #define USMBD_CHARSET_DEFAULT		USMBD_CHARSET_UTF8
diff -urpN ksmbd-tools-3.1.0/lib/config_parser.c ksmbd-tools-3.1.0.new/lib/config_parser.c
--- ksmbd-tools-3.1.0/lib/config_parser.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/config_parser.c	2020-01-26 14:06:09.634412732 +0400
@@ -5,13 +5,14 @@
  *   linux-cifsd-devel@lists.sourceforge.net
  */
 
-#include <glib.h>
 #include <string.h>
-#include <glib/gstdio.h>
 #include <sys/stat.h>
 #include <sys/types.h>
 #include <unistd.h>
 #include <fcntl.h>
+#include <ctype.h>
+#include <sys/mman.h>
+#include <limits.h>
 #include <linux/usmbd_server.h>
 
 #include <config_parser.h>
@@ -52,9 +53,9 @@ unsigned long long memparse(const char *
 	return ret;
 }
 
-static void kv_release_cb(gpointer p)
+static void kv_release_cb(void *p, unsigned long long id, void *user_data)
 {
-	g_free(p);
+	free(p);
 }
 
 static int is_ascii_space_tab(char c)
@@ -67,6 +68,18 @@ static int is_a_comment(char *line)
 	return (*line == 0x00 || *line == ';' || *line == '\n' || *line == '#');
 }
 
+static char *utf8_find_next_char(const char *p, const char *end)
+{
+	if (end) {
+		for (++p; p < end && (*p & 0xc0) == 0x80; ++p)
+		;
+		return (p >= end) ? NULL : (char *)p;
+	}
+	for (++p; (*p & 0xc0) == 0x80; ++p)
+	;
+	return (char *)p;
+}
+
 static int is_a_group(char *line)
 {
 	char *p = line;
@@ -75,7 +88,7 @@ static int is_a_group(char *line)
 		return 0;
 	p++;
 	while (*p && *p != ']')
-		p = g_utf8_find_next_char(p, NULL);
+		p = utf8_find_next_char(p, NULL);
 	if (*p != ']')
 		return 0;
 	return 1;
@@ -90,42 +103,40 @@ static int add_new_group(char *line)
 	struct smbconf_group *lookup;
 
 	while (*end && *end != ']')
-		end = g_utf8_find_next_char(end, NULL);
+		end = utf8_find_next_char(end, NULL);
 
-	name = g_ascii_strdown(begin + 1, end - begin - 1);
+	name = ascii_strdown(begin + 1, end - begin - 1);
 	if (!name)
 		goto out_free;
 
-	lookup = g_hash_table_lookup(parser.groups, name);
+	lookup = list_get(&parser.groups, list_tokey(name));
 	if (lookup) {
 		parser.current = lookup;
-		pr_info("SMB conf: multiple group definitions `%s'\n",
-				name);
-		g_free(name);
+		pr_info("SMB conf: multiple group definitions `%s'\n", name);
+		free(name);
 		return 0;
 	}
 
-	group = g_malloc(sizeof(struct smbconf_group));
+	group = malloc(sizeof(struct smbconf_group));
 	if (!group)
 		goto out_free;
 
 	group->name = name;
-	group->kv = g_hash_table_new_full(g_str_hash,
-					  g_str_equal,
-					  kv_release_cb,
-					  kv_release_cb);
+	list_init(&group->kv);
+
 	if (!group->kv)
 		goto out_free;
 
 	parser.current = group;
-	g_hash_table_insert(parser.groups, group->name, group);
+	list_add_str(&parser.groups, group, group->name);
+
 	return 0;
 
 out_free:
-	g_free(name);
+	free(name);
 	if (group && group->kv)
-		g_hash_table_destroy(group->kv);
-	g_free(group);
+		list_clear(&group->kv);
+	free(group);
 	return -ENOMEM;
 }
 
@@ -150,22 +161,22 @@ static int add_group_key_value(char *lin
 	if (is_a_comment(value))
 		return 0;
 
-	if (g_hash_table_lookup(parser.current->kv, key)) {
+	if (list_get(&parser.current->kv, list_tokey(key))) {
 		pr_info("SMB conf: multuple key-value [%s] %s\n",
-				parser.current->name, key);
+			parser.current->name, key);
 		return 0;
 	}
 
-	key = g_strndup(line, key - line + 1);
-	value = g_strdup(value);
+	key = strndup(line, key - line + 1);
+	value = strdup(value);
 
 	if (!key || !value) {
-		g_free(key);
-		g_free(value);
+		free(key);
+		free(value);
 		return -ENOMEM;
 	}
 
-	g_hash_table_insert(parser.current->kv, key, value);
+	list_add_str(&parser.current->kv, value, key);
 	return 0;
 }
 
@@ -183,35 +194,29 @@ static int process_smbconf_entry(char *d
 	return add_group_key_value(data);
 }
 
-static int __mmap_parse_file(const char *fname, int (*callback)(char *data))
+static int __mmap_parse_file(const char *fname, int (*callback)(char *d))
 {
-	GMappedFile *file;
-	GError *err = NULL;
-	gchar *contents;
-	int len;
+	char *contents, *buf;
+	size_t len;
 	char *delim;
-	int fd, ret = 0;
+	int ret = 0;
+	FILE *fd;
 
-	fd = g_open(fname, O_RDONLY, 0);
-	if (fd == -1) {
+	fd = fopen(fname, "rb");
+	if (fd == NULL) {
 		ret = errno;
 		pr_err("Can't open `%s': %s\n", fname, strerr(ret));
 		return -ret;
 	}
-
-	file = g_mapped_file_new_from_fd(fd, FALSE, &err);
-	if (err) {
-		pr_err("%s: `%s'\n", err->message, fname);
-		g_error_free(err);
-		ret = -EINVAL;
-		goto out;
-	}
-
-	contents = g_mapped_file_get_contents(file);
+	fseek(fd, 0, SEEK_END);
+	len = ftell(fd);
+	rewind(fd);
+	buf = contents = malloc(len + 1);
 	if (!contents)
 		goto out;
+	fread(contents, 1, len, fd);
+	contents[len] = 0;
 
-	len = g_mapped_file_get_length(file);
 	while (len > 0) {
 		delim = strchr(contents, '\n');
 		if (!delim)
@@ -219,7 +224,6 @@ static int __mmap_parse_file(const char
 
 		if (delim) {
 			size_t sz = delim - contents;
-			char *data;
 
 			if (delim == contents) {
 				contents = delim + 1;
@@ -229,23 +233,15 @@ static int __mmap_parse_file(const char
 
 			if (!sz)
 				break;
-
-			data = g_malloc(sz + 1);
-			if (!data) {
-				ret = -ENOMEM;
-				goto out;
-			}
-
-			strncpy(data, contents, sz);
-			data[sz] = 0x00;
+			char *data = strndup(contents, sz);
 
 			ret = callback(data);
 			if (ret) {
-				g_free(data);
+				free(data);
 				goto out;
 			}
+			free(data);
 
-			g_free(data);
 			contents = delim + 1;
 			len -= (sz + 1);
 		}
@@ -253,16 +249,12 @@ static int __mmap_parse_file(const char
 
 	ret = 0;
 out:
-	if (file)
-		g_mapped_file_unref(file);
+	if (buf)
+		free(buf);
+
+	if (fd)
+		fclose(fd);
 
-	if (fd) {
-		g_close(fd, &err);
-		if (err) {
-			pr_err("%s: %s\n", err->message, fname);
-			g_error_free(err);
-		}
-	}
 	return ret;
 }
 
@@ -271,28 +263,29 @@ static int init_smbconf_parser(void)
 	if (parser.groups)
 		return 0;
 
-	parser.groups = g_hash_table_new(g_str_hash, g_str_equal);
+	list_init(&parser.groups);
 	if (!parser.groups)
 		return -ENOMEM;
 	return 0;
 }
 
-static void release_smbconf_group(gpointer k, gpointer v, gpointer user_data)
+static void release_smbconf_group(void *v, unsigned long long id,
+				  void *user_data)
 {
 	struct smbconf_group *g = v;
 
-	g_hash_table_destroy(g->kv);
-	g_free(g->name);
-	g_free(g);
+	list_foreach(&g->kv, kv_release_cb, NULL);
+	list_clear(&g->kv);
+	free(g->name);
+	free(g);
 }
 
 static void release_smbconf_parser(void)
 {
 	if (!parser.groups)
 		return;
-
-	g_hash_table_foreach(parser.groups, release_smbconf_group, NULL);
-	g_hash_table_destroy(parser.groups);
+	list_foreach(&parser.groups, release_smbconf_group, NULL);
+	list_clear(&parser.groups);
 	parser.groups = NULL;
 }
 
@@ -312,33 +305,32 @@ int cp_key_cmp(char *k, char *v)
 {
 	if (!k || !v)
 		return -1;
-	return g_ascii_strncasecmp(k, v, strlen(v));
+	return strncasecmp(k, v, strlen(v));
 }
 
 char *cp_get_group_kv_string(char *v)
 {
-	return g_strdup(v);
+	return strdup(v);
 }
 
 int cp_get_group_kv_bool(char *v)
 {
-	if (!g_ascii_strncasecmp(v, "yes", 3) ||
-		!g_ascii_strncasecmp(v, "1", 1) ||
-		!g_ascii_strncasecmp(v, "true", 4) ||
-		!g_ascii_strncasecmp(v, "enable", 6))
+	if (!strncasecmp(v, "yes", 3) ||
+	    !strncasecmp(v, "1", 1) ||
+	    !strncasecmp(v, "true", 4) || !strncasecmp(v, "enable", 6))
 		return 1;
 	return 0;
 }
 
 int cp_get_group_kv_config_opt(char *v)
 {
-	if (!g_ascii_strncasecmp(v, "disabled", 8))
+	if (!strncasecmp(v, "disabled", 8))
 		return USMBD_CONFIG_OPT_DISABLED;
-	if (!g_ascii_strncasecmp(v, "enabled", 7))
+	if (!strncasecmp(v, "enabled", 7))
 		return USMBD_CONFIG_OPT_ENABLED;
-	if (!g_ascii_strncasecmp(v, "auto", 4))
+	if (!strncasecmp(v, "auto", 4))
 		return USMBD_CONFIG_OPT_AUTO;
-	if (!g_ascii_strncasecmp(v, "mandatory", 9))
+	if (!strncasecmp(v, "mandatory", 9))
 		return USMBD_CONFIG_OPT_MANDATORY;
 	return USMBD_CONFIG_OPT_DISABLED;
 }
@@ -353,25 +345,110 @@ unsigned long cp_get_group_kv_long(char
 	return cp_get_group_kv_long_base(v, 10);
 }
 
+struct SList {
+	void *data;
+	struct SList *next;
+};
+
+struct SList *slist_prepend(struct SList *list, void *data)
+{
+	struct SList *new_list;
+
+	new_list = malloc(sizeof(*list));
+	new_list->data = data;
+	new_list->next = list;
+
+	return new_list;
+}
+
+static char **strsplit_set(const char *string,
+			   const char *delimiters, int max_tokens)
+{
+	unsigned int delim_table[256];
+	struct SList *list, *tokens;
+	int n_tokens;
+	const char *s;
+	const char *current;
+	char *token;
+	char **result;
+
+	if (!string || !delimiters)
+		return NULL;
+
+	if (max_tokens < 1)
+		max_tokens = INT_MAX;
+
+	if (*string == '\0') {
+		result = malloc(sizeof(char *));
+		result[0] = NULL;
+		return result;
+	}
+
+	memset(delim_table, 0, sizeof(delim_table));
+	for (s = delimiters; *s != '\0'; ++s)
+		delim_table[*(unsigned char *)s] = 1;
+
+	tokens = NULL;
+	n_tokens = 0;
+
+	s = current = string;
+	while (*s != '\0') {
+		if (delim_table[*(unsigned char *)s]
+		    && n_tokens + 1 < max_tokens) {
+			token = strndup(current, s - current);
+			tokens = slist_prepend(tokens, token);
+			++n_tokens;
+
+			current = s + 1;
+		}
+
+		++s;
+	}
+
+	token = strndup(current, s - current);
+	tokens = slist_prepend(tokens, token);
+	++n_tokens;
+
+	result = malloc(sizeof(char *) * (n_tokens + 1));
+
+	result[n_tokens] = NULL;
+	for (list = tokens; list != NULL; list = list->next)
+		result[--n_tokens] = list->data;
+
+	list = tokens;
+	while (list) {
+		struct SList *old = list;
+
+		list = list->next;
+		free(old);
+	}
+	return result;
+}
+
 char **cp_get_group_kv_list(char *v)
 {
 	/*
 	 * SMB conf lists are "tabs, spaces, commas" separated.
 	 */
-	return g_strsplit_set(v, "\t ,", -1);
+	return strsplit_set(v, "\t ,", -1);
 }
 
 void cp_group_kv_list_free(char **list)
 {
-	g_strfreev(list);
+	if (list) {
+		int i;
+
+		for (i = 0; list[i] != NULL; i++)
+			free(list[i]);
+		free(list);
+	}
 }
 
-static int cp_add_global_guest_account(gpointer _v)
+static int cp_add_global_guest_account(void *_v)
 {
 	struct usmbd_user *user;
 
-	if (usm_add_new_user(cp_get_group_kv_string(_v),
-			     g_strdup("NULL"))) {
+	if (usm_add_new_user(cp_get_group_kv_string(_v), strdup("NULL"))) {
 		pr_err("Unable to add guest account\n");
 		return -ENOMEM;
 	}
@@ -379,7 +456,7 @@ static int cp_add_global_guest_account(g
 	user = usm_lookup_user(_v);
 	if (!user) {
 		pr_err("Fatal error: unable to find `%s' account.\n",
-			(const char *) _v);
+		       (const char *)_v);
 		return -EINVAL;
 	}
 
@@ -389,8 +466,10 @@ static int cp_add_global_guest_account(g
 	return 0;
 }
 
-static void global_group_kv(gpointer _k, gpointer _v, gpointer user_data)
+static void global_group_kv(void *_v, unsigned long long id, void *user_data)
 {
+	void *_k = list_fromkey(id);
+
 	if (!cp_key_cmp(_k, "server string")) {
 		global_conf.server_string = cp_get_group_kv_string(_v);
 		return;
@@ -450,7 +529,7 @@ static void global_group_kv(gpointer _k,
 	if (!cp_key_cmp(_k, "restrict anonymous")) {
 		global_conf.restrict_anon = cp_get_group_kv_long(_v);
 		if (global_conf.restrict_anon > USMBD_RESTRICT_ANON_TYPE_2 ||
-				global_conf.restrict_anon < 0) {
+		    global_conf.restrict_anon < 0) {
 			global_conf.restrict_anon = 0;
 			pr_err("Invalid restrict anonymous value\n");
 		}
@@ -462,13 +541,13 @@ static void global_group_kv(gpointer _k,
 		global_conf.map_to_guest = USMBD_CONF_MAP_TO_GUEST_NEVER;
 		if (!cp_key_cmp(_v, "bad user"))
 			global_conf.map_to_guest =
-				USMBD_CONF_MAP_TO_GUEST_BAD_USER;
+			    USMBD_CONF_MAP_TO_GUEST_BAD_USER;
 		if (!cp_key_cmp(_v, "bad password"))
 			global_conf.map_to_guest =
-				USMBD_CONF_MAP_TO_GUEST_BAD_PASSWORD;
+			    USMBD_CONF_MAP_TO_GUEST_BAD_PASSWORD;
 		if (!cp_key_cmp(_v, "bad uid"))
 			global_conf.map_to_guest =
-				USMBD_CONF_MAP_TO_GUEST_BAD_UID;
+			    USMBD_CONF_MAP_TO_GUEST_BAD_UID;
 		return;
 	}
 
@@ -563,14 +642,13 @@ static void fixup_missing_global_group(v
 		global_conf.file_max = USMBD_CONF_FILE_MAX;
 	if (!global_conf.server_string)
 		global_conf.server_string =
-			cp_get_group_kv_string(
-					USMBD_CONF_DEFAULT_SERVER_STRING);
+		    cp_get_group_kv_string(USMBD_CONF_DEFAULT_SERVER_STRING);
 	if (!global_conf.netbios_name)
 		global_conf.netbios_name =
-			cp_get_group_kv_string(USMBD_CONF_DEFAULT_NETBIOS_NAME);
+		    cp_get_group_kv_string(USMBD_CONF_DEFAULT_NETBIOS_NAME);
 	if (!global_conf.work_group)
 		global_conf.work_group =
-			cp_get_group_kv_string(USMBD_CONF_DEFAULT_WORK_GROUP);
+		    cp_get_group_kv_string(USMBD_CONF_DEFAULT_WORK_GROUP);
 	if (!global_conf.tcp_port)
 		global_conf.tcp_port = USMBD_CONF_DEFAULT_TPC_PORT;
 
@@ -586,7 +664,7 @@ static void fixup_missing_global_group(v
 	ret = cp_add_global_guest_account(USMBD_CONF_FALLBACK_GUEST_ACCOUNT);
 	if (ret)
 		pr_err("Fatal error: Cannot set a global guest account %d\n",
-			ret);
+		       ret);
 }
 
 static void default_global_group(void)
@@ -597,20 +675,22 @@ static void default_global_group(void)
 
 static void global_group(struct smbconf_group *group)
 {
-	g_hash_table_foreach(group->kv, global_group_kv, NULL);
+	list_foreach(&group->kv, global_group_kv, NULL);
 }
 
 #define GROUPS_CALLBACK_STARTUP_INIT	0x1
 #define GROUPS_CALLBACK_REINIT		0x2
 
-static void groups_callback(gpointer _k, gpointer _v, gpointer flags)
+static void groups_callback(void *_v, unsigned long long id, void *flags)
 {
-	if (g_ascii_strncasecmp(_k, "global", 6)) {
+	void *_k = list_fromkey(id);
+
+	if (strncasecmp(_k, "global", 6)) {
 		shm_add_new_share((struct smbconf_group *)_v);
 		return;
 	}
 
-	if (flags == (gpointer)GROUPS_CALLBACK_STARTUP_INIT)
+	if (flags == (void *)GROUPS_CALLBACK_STARTUP_INIT)
 		global_group((struct smbconf_group *)_v);
 }
 
@@ -619,10 +699,10 @@ static int cp_add_ipc_share(void)
 	char *comment = NULL;
 	int ret = 0;
 
-	if (g_hash_table_lookup(parser.groups, "ipc$"))
+	if (list_get(&parser.groups, list_tokey("ipc$")))
 		return 0;
 
-	comment = g_strdup("comment = IPC share");
+	comment = strdup("comment = IPC share");
 	ret = add_new_group("[IPC$]");
 	ret |= add_group_key_value(comment);
 	if (ret) {
@@ -633,11 +713,11 @@ static int cp_add_ipc_share(void)
 	return ret;
 
 out:
-	g_free(comment);
+	free(comment);
 	return ret;
 }
 
-static int __cp_parse_smbconfig(const char *smbconf, GHFunc cb, long flags)
+static int __cp_parse_smbconfig(const char *smbconf, long flags)
 {
 	int ret;
 
@@ -649,9 +729,7 @@ static int __cp_parse_smbconfig(const ch
 
 	ret = cp_add_ipc_share();
 	if (!ret) {
-		g_hash_table_foreach(parser.groups,
-				     groups_callback,
-				     (gpointer)flags);
+		list_foreach(&parser.groups, groups_callback, (void *)flags);
 		fixup_missing_global_group();
 	}
 	cp_smbconfig_destroy();
@@ -660,16 +738,12 @@ static int __cp_parse_smbconfig(const ch
 
 int cp_parse_reload_smbconf(const char *smbconf)
 {
-	return __cp_parse_smbconfig(smbconf,
-				    groups_callback,
-				    GROUPS_CALLBACK_REINIT);
+	return __cp_parse_smbconfig(smbconf, GROUPS_CALLBACK_REINIT);
 }
 
 int cp_parse_smbconf(const char *smbconf)
 {
-	return __cp_parse_smbconfig(smbconf,
-				    groups_callback,
-				    GROUPS_CALLBACK_STARTUP_INIT);
+	return __cp_parse_smbconfig(smbconf, GROUPS_CALLBACK_STARTUP_INIT);
 }
 
 int cp_parse_pwddb(const char *pwddb)
